<?php
namespace App\modele;
use App\gateway\AlumniGateway;
use App\gateway\Connection;
use App\gateway\OffreGateway;
use App\gateway\ProfilGateway;
use App\metier\Alumni;
use App\metier\Offre;

class UtilisateurModele
{
    /**
     * @description Charger le flux d'activiter
     * @return array flux
     */
    public function LoadFeed() : array
    {
        // TO DO
        return [];
    }

    private OffreGateway $offreGw;

    public function __construct()
    {
        $this->offreGw = new OffreGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "Dev", "Dev"));
    }

    /**
     * @description se connecter
     * @param string email
     * @param string hash
     * @return \App\metier\Alumni
     */

    public function connection(string $email, string $mdp) : ? \App\metier\Alumni
    {
        $con = new \App\gateway\Connection(DB_HOST,DB_USER,DB_PASS);
        $gate = new \App\gateway\AlumniGateway($con);
        // Récupérez l'utilisateur avec l'email donné en utilisant AlumniGateway
        $utilisateur = $gate->findByEmail($email);
        if ($utilisateur instanceof \App\metier\Alumni) {
            // L'utilisateur existe, vérifiez le mot de passe
            if (password_verify($mdp, $utilisateur->getPassword())) {
                // Le mot de passe est correct, retournez l'utilisateur
                session_start();
                return $utilisateur;
            } else {
                // Le mot de passe est incorrect, renvoyez null
                return null;
            }
        } else {
            // L'utilisateur n'existe pas, renvoyez null
            return null;
        }
    }

    /**
     * @description s'inscrire
     * @param string email
     * @param string hash
     * @param string $pseudo
     * @return \Alumni chargé
     */

    public function inscription(string $prenom, string $nom,string $email, string $hashpassword):? \App\metier\Alumni
    {
        $role = "Membre";
        $con = new \App\gateway\Connection(DB_HOST,DB_USER,DB_PASS);
        $gate = new \App\gateway\AlumniGateway($con);
        $profilGate = new \App\gateway\ProfilGateway($con);
        // Insérez le nouvel utilisateur dans la base de données en utilisant AlumniGateway
        if ($gate->insert($email, $hashpassword, $role)) {
// <<<<<<< HEAD
//             // L'insertion a réussi, retournez le nouvel utilisateur
//             $nouvelUtilisateur = new \App\metier\Alumni($email, $hashpassword, $role);
//             return $nouvelUtilisateur;
//         } else {
//             // L'insertion a échoué, renvoyez un utilisateur vide pour indiquer l'échec
//             return new \App\metier\Alumni(null, null,  null);
// =======
            $alumni = $gate->getID($email);
            if($profilGate->insert($alumni,$nom, $prenom,$email)){
                // L'insertion a réussi, retournez le nouvel utilisateur
                $nouvelUtilisateur = new \App\metier\Alumni($email, $hashpassword, $role,$nom,$prenom);
                return $nouvelUtilisateur;
            }
            return null;
        } else {
            // L'insertion a échoué, renvoyez un utilisateur vide pour indiquer l'échec
            return null;
        }
    }

    public function getUtilisateurByEmail(string $email) 
    {
        $con = new \App\gateway\Connection(DB_HOST,DB_USER,DB_PASS);
        $gate = new \App\gateway\AlumniGateway($con);
        // Récupérez l'utilisateur avec l'email donné en utilisant AlumniGateway
        $utilisateur = $gate->findByEmail($email);
        if ($utilisateur instanceof \App\metier\Alumni) {
            // L'utilisateur existe, retournez-le
            return $utilisateur;
        } else {
            // L'utilisateur n'existe pas, renvoyez null
            return null;
        }
    }

    public function getOffers() : array
    {
        $res = $this->offreGw->getOffers();
        $offers = $this->CreateOffersFromGw($res);
        return $offers;
    }

    public function getOfferFromId(int $id) : ?Offre
    {
        $res = $this->offreGw->getOfferFromId($id);
        if($res != null)
            return $this->CreateOffersFromGw($res)[0];
        return null;
    }

    public function CreateOffersFromGw($res) : array
    {
        $alGw = new AlumniGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "test", "test"));

        $offers=[];
        foreach ($res as $row)
        {
            $resal = $alGw->ObtenirById($row['offreur']);



            $profilGw = new ProfilGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "Dev", "Dev"));
            $resProfl = $profilGw->getProfilById($row['offreur']);

            $alumni = new Alumni($resal[0]['mail'],$resal[0]['mdp'],$resal[0]['role'],$resProfl[0]['nom'],$resProfl[0]["prenom"]);

            $date = \DateTime::createFromFormat('Y-m-d', $row['date']);

            $offers[]=new Offre(
                $row['id'],
                $alumni,
                $row['titre'],
                $row['description'],
                $row["image"],
                $row["logo"],
                $row['typeContrat'],
                $row['ville'],
                $row["entreprise"],
                $row['descriptifPoste'],
                $row['profil'],
                $row['experience'],
                $row['niveauEtudes'],
                $row['mailContact'],
                $row['numero'],
                $row['websiteURL'],
                $row['remote'],
                $date);
        }


        return $offers;
    }

    public function getOfferLimit($start, $nbOffers): array
    {
        $res = $this->offreGw->getOfferLimit($start, $nbOffers);
        return $this->CreateOffersFromGw($res);
    }

    public function getNbOffers() : int
    {
        return $this->offreGw->getNbOffers();
    }



    public function getOffersWithFilters($params) : array
    {
        return $this->offreGw->getOffersWithFilters($params);
    }


    public function publishOffer(string $img,string $logo)
    {
        $desc = $_POST["description"];
        $descposte = $_POST["descriptPoste"];
        $nom = $_POST["name"];
        $ville = $_POST["ville"];
        $entreprise = $_POST["entreprise"];
        $profilRecherche = $_POST["profilRecherche"];
        $mail = $_POST["mail"];
        $num = $_POST["num"];
        $site = $_POST["site"];
        $exp = $_POST["choixExp"];
        $typeContrat = $_POST["typeContrat"];
        $niveauEtudes = $_POST["education"];
        $date = new \DateTime();

        if(isset($_POST["fullRemote"]))
        {
            $remote = true;
        }
        else $remote = false;

        // à la place de NULL passer id utilisateur créateur offre
        $offre = new Offre($this->offreGw->getNewId(),
            new Alumni("test.mail@icloud.fr","password","admin","prenom","nom"),
            $nom,
            $desc,
            $img,
            $logo,
            $typeContrat,
            $ville,
            $entreprise,
            $descposte,
            $profilRecherche,
            $exp,
            $niveauEtudes,
            $mail,
            $num,
            $site,
            $remote,
            $date);

        $this->offreGw->addOffers($offre);

        return $offre;
    }


}
